import 'package:backend_dart/application/repository/project_repository_impl.dart';
import 'package:backend_dart/application/repository/project_task_repository_impl.dart';
import 'package:backend_dart/application/repository/time_entry_repository_impl.dart';
import 'package:backend_dart/application/repository/user_repository_impl.dart';
import 'package:backend_dart/domain/repository/project_repository.dart';
import 'package:backend_dart/domain/repository/project_task_repository.dart';
import 'package:backend_dart/domain/repository/time_entry_repository.dart';
import 'package:backend_dart/domain/repository/user_repository.dart';
import 'package:backend_dart/infrastructure/persistence/database_provider.dart';
import 'package:riverpod/riverpod.dart';

final userRepoProvider = Provider<UserRepository>((ref) {
  final database = ref.read(databaseProvider);
  return UserRepositoryImpl(database);
});

final projectTaskProvider = Provider<ProjectTaskRepository>((ref) {
  final database = ref.read(databaseProvider);
  return ProjectTaskRepositoryImpl(database);
});

final projectProvider = Provider<ProjectRepository>((ref) {
  final database = ref.read(databaseProvider);
  return ProjectRepositoryImpl(database);
});

final timeEntryProvider = Provider<TimeEntryRepository>((ref) {
  final database = ref.read(databaseProvider);
  return TimeEntryRepositoryImpl(database);
});
