import 'package:freezed_annotation/freezed_annotation.dart';

part 'project_dto.freezed.dart';
part 'project_dto.g.dart';

@freezed
class ProjectDto with _$ProjectDto {
  const factory ProjectDto({
    required String id,
    required String name,
    String? description,
    String? clientId,
    required String userId,
    required DateTime createdAt,
    required DateTime updatedAt,
  }) = _ProjectDto;

  /// JSON-Serialisierung
  factory ProjectDto.fromJson(Map<String, dynamic> json) =>
      _$ProjectDtoFromJson(json);
}

@freezed
class ProjectCreateDto with _$ProjectCreateDto {
  const factory ProjectCreateDto({
    required String name,
    String? description,
    String? clientId,
    required String userId,
  }) = _ProjectCreateDto;

  /// JSON-Serialisierung
  factory ProjectCreateDto.fromJson(Map<String, dynamic> json) =>
      _$ProjectCreateDtoFromJson(json);
}

@freezed
class ProjectUpdateDto with _$ProjectUpdateDto {
  const factory ProjectUpdateDto({
    String? name,
    String? description,
    String? clientId,
    String? userId,
  }) = _ProjectUpdateDto;

  /// JSON-Serialisierung
  factory ProjectUpdateDto.fromJson(Map<String, dynamic> json) =>
      _$ProjectUpdateDtoFromJson(json);
}
