import 'package:freezed_annotation/freezed_annotation.dart';

part 'project_task_dto.freezed.dart';
part 'project_task_dto.g.dart';

@freezed
class ProjectTaskDto with _$ProjectTaskDto {
  const factory ProjectTaskDto({
    required String id,
    required String name,
    String? description,
    required String projectId,
    required DateTime createdAt,
    required DateTime updatedAt,
  }) = _ProjectTaskDto;

  /// JSON-Serialisierung
  factory ProjectTaskDto.fromJson(Map<String, dynamic> json) =>
      _$ProjectTaskDtoFromJson(json);
}

@freezed
class ProjectTaskCreateDto with _$ProjectTaskCreateDto {
  const factory ProjectTaskCreateDto({
    required String name,
    String? description,
    required String projectId,
  }) = _ProjectTaskCreateDto;

  /// JSON-Serialisierung
  factory ProjectTaskCreateDto.fromJson(Map<String, dynamic> json) =>
      _$ProjectTaskCreateDtoFromJson(json);
}

@freezed
class ProjectTaskUpdateDto with _$ProjectTaskUpdateDto {
  const factory ProjectTaskUpdateDto({
    String? name,
    String? description,
    String? projectId,
  }) = _ProjectTaskUpdateDto;

  /// JSON-Serialisierung
  factory ProjectTaskUpdateDto.fromJson(Map<String, dynamic> json) =>
      _$ProjectTaskUpdateDtoFromJson(json);
}
