import 'package:freezed_annotation/freezed_annotation.dart';

part 'time_entry_dto.freezed.dart';
part 'time_entry_dto.g.dart';

@freezed
class TimeEntryDto with _$TimeEntryDto {
  const factory TimeEntryDto({
    required String id,
    required DateTime startTime,
    required DateTime? endTime,
    String? description,
    required String userId,
    required String projectId,
    required DateTime createdAt,
    required DateTime updatedAt,
  }) = _TimeEntryDto;

  /// JSON-Serialisierung
  factory TimeEntryDto.fromJson(Map<String, dynamic> json) =>
      _$TimeEntryDtoFromJson(json);
}

@freezed
class TimeEntryCreateDto with _$TimeEntryCreateDto {
  const factory TimeEntryCreateDto({
    required DateTime startTime,
    DateTime? endTime,
    String? description,
    required String userId,
    required String projectId,
  }) = _TimeEntryCreateDto;

  /// JSON-Serialisierung
  factory TimeEntryCreateDto.fromJson(Map<String, dynamic> json) =>
      _$TimeEntryCreateDtoFromJson(json);
}

@freezed
class TimeEntryUpdateDto with _$TimeEntryUpdateDto {
  const factory TimeEntryUpdateDto({
    DateTime? startTime,
    DateTime? endTime,
    String? description,
    String? userId,
    String? projectId,
  }) = _TimeEntryUpdateDto;

  /// JSON-Serialisierung
  factory TimeEntryUpdateDto.fromJson(Map<String, dynamic> json) =>
      _$TimeEntryUpdateDtoFromJson(json);
}
