import 'package:freezed_annotation/freezed_annotation.dart';

part 'user_dto.freezed.dart';
part 'user_dto.g.dart';

@freezed
class UserDto with _$UserDto {
  const factory UserDto({
    required String id,
    required String name,
    required String email,
    DateTime? createdAt,
    DateTime? updatedAt,
  }) = _UserDto;

  /// JSON-Serialisierung
  factory UserDto.fromJson(Map<String, dynamic> json) => _$UserDtoFromJson(json);
}

@freezed
class UserCreateDto with _$UserCreateDto {
  const factory UserCreateDto({
    required String name,
    required String email,
    required String password,
  }) = _UserCreateDto;

  /// JSON-Serialisierung
  factory UserCreateDto.fromJson(Map<String, dynamic> json) =>
      _$UserCreateDtoFromJson(json);
}

@freezed
class UserUpdateDto with _$UserUpdateDto {
  const factory UserUpdateDto({
    String? name,
    String? email,
    String? password,
  }) = _UserUpdateDto;

  /// JSON-Serialisierung
  factory UserUpdateDto.fromJson(Map<String, dynamic> json) =>
      _$UserUpdateDtoFromJson(json);
}
