import 'package:backend_dart/application/service/dto/project_task_dto.dart';
import 'package:backend_dart/domain/entities/project_task.dart';
import 'package:backend_dart/domain/interface/error.dart';
import 'package:fpdart/fpdart.dart';

class ProjectTaskDtoMapper {
  TaskEither<IError, ProjectTaskDto> to(ProjectTask entity) =>
      TaskEither.of(ProjectTaskDto(
        id: entity.id,
        name: entity.name,
        description: entity.description,
        projectId: entity.projectId,
        createdAt: entity.createdAt,
        updatedAt: entity.updatedAt,
      ));

  TaskEither<IError, List<ProjectTaskDto>> listTo(
      Iterable<ProjectTask> origins) {
    return TaskEither.traverseList(origins.toList(), to);
  }

  TaskEither<IError, ProjectTaskCreate> fromCreateTo(
          ProjectTaskCreateDto origin) =>
      TaskEither.of(ProjectTaskCreate(
        name: origin.name,
        description: origin.description,
        projectId: origin.projectId,
      ));

  TaskEither<IError, ProjectTaskUpdate> fromUpdateTo(
      ProjectTaskUpdateDto origin, String id) =>
      TaskEither.of(ProjectTaskUpdate(
        id: id,
        name: origin.name,
        description: origin.description,
        projectId: origin.projectId,
      ));
}
