import 'package:backend_dart/application/service/dto/time_entry_dto.dart';
import 'package:backend_dart/domain/entities/time_entry.dart';
import 'package:backend_dart/domain/interface/error.dart';
import 'package:fpdart/fpdart.dart';

class TimeEntryDtoMapper {
  TaskEither<IError, TimeEntryDto> to(TimeEntry entity) => TaskEither.of(
        TimeEntryDto(
          id: entity.id,
          startTime: entity.startTime,
          endTime: entity.endTime,
          description: entity.description,
          userId: entity.userId,
          projectId: entity.projectId,
          createdAt: entity.createdAt,
          updatedAt: entity.updatedAt,
        ),
      );

  TaskEither<IError, List<TimeEntryDto>> listTo(Iterable<TimeEntry> origins) {
    return TaskEither.traverseList(origins.toList(), to);
  }

  TaskEither<IError, TimeEntryCreate> fromCreateTo(TimeEntryCreateDto origin) =>
      TaskEither.of(TimeEntryCreate(
        startTime: origin.startTime,
        endTime: origin.endTime,
        description: origin.description,
        userId: origin.userId,
        projectId: origin.projectId,
      ));

  TaskEither<IError, TimeEntryUpdate> fromUpdateTo(
          TimeEntryUpdateDto origin, String id) =>
      TaskEither.of(TimeEntryUpdate(
        id: id,
        startTime: origin.startTime,
        endTime: origin.endTime,
        description: origin.description,
        userId: origin.userId,
        projectId: origin.projectId,
      ));
}
