import 'package:backend_dart/application/service/dto/user_dto.dart';
import 'package:backend_dart/domain/entities/user.dart';
import 'package:backend_dart/domain/interface/error.dart';
import 'package:fpdart/fpdart.dart';

class UserDtoMapper {
  TaskEither<IError, UserDto> to(User entity) => TaskEither.of(UserDto(
        id: entity.id,
        name: entity.name,
        email: entity.email,
        createdAt: entity.createdAt,
        updatedAt: entity.updatedAt,
      ));

  TaskEither<IError, List<UserDto>> listTo(Iterable<User> origins) {
    return TaskEither.traverseList(origins.toList(), to);
  }

  TaskEither<IError, UserCreate> fromCreateTo(UserCreateDto origin) =>
      TaskEither.of(UserCreate(
        name: origin.name,
        email: origin.email,
        password: origin.password,
      ));

  TaskEither<IError, UserUpdate> fromUpdateTo(
          UserUpdateDto origin, String id) =>
      TaskEither.of(UserUpdate(
        id: id,
        name: origin.name,
        email: origin.email,
        password: origin.password,
      ));
}
