import 'package:backend_dart/application/repository/provider.dart';
import 'package:backend_dart/application/service/project_service.dart';
import 'package:backend_dart/application/service/project_task_service.dart';
import 'package:backend_dart/application/service/time_entry_service.dart';
import 'package:backend_dart/application/service/user_service.dart';
import 'package:riverpod/riverpod.dart';

final userServiceProvider = Provider<UserService>((ref) {
  final database = ref.read(userRepoProvider);
  return UserService(database);
});

final projectServiceProvider = Provider<ProjectService>((ref) {
  final database = ref.read(projectProvider);
  return ProjectService(database);
});

final projectTaskServiceProvider = Provider<ProjectTaskService>((ref) {
  final database = ref.read(projectTaskProvider);
  return ProjectTaskService(database);
});

final timeEntryServiceProvider = Provider<TimeEntryService>((ref) {
  final database = ref.read(timeEntryProvider);
  return TimeEntryService(database);
});