import 'package:backend_dart/domain/entities/user.dart';
import 'package:backend_dart/domain/interface/error.dart';
import 'package:fpdart/fpdart.dart';

abstract class UserDataSource {
  TaskEither<IError, User> create(UserCreate user);

  TaskEither<IError, User> findByEmail(String email);

  TaskEither<IError, User> findById(String id);

  TaskEither<IError, User> update(UserUpdate user);

  TaskEither<IError, void> delete(String id);

  TaskEither<IError, List<User>> findAll();

  TaskEither<IError, String> generateId();
}
