import 'package:freezed_annotation/freezed_annotation.dart';

part 'project_task.freezed.dart';

@freezed
class ProjectTask with _$ProjectTask {
  const factory ProjectTask({
    required String id,
    required String name,
    String? description,
    required String projectId,
    required DateTime createdAt,
    required DateTime updatedAt,
  }) = _ProjectTask;
}

@freezed
class ProjectTaskCreate with _$ProjectTaskCreate {
  const factory ProjectTaskCreate({
    String? id,
    required String name,
    String? description,
    required String projectId,
  }) = _ProjectTaskCreate;
}

@freezed
class ProjectTaskUpdate with _$ProjectTaskUpdate {
  const factory ProjectTaskUpdate({
    required String id,
    String? name,
    String? description,
    String? projectId,
  }) = _ProjectTaskUpdate;
}
