import 'package:freezed_annotation/freezed_annotation.dart';

part 'time_entry.freezed.dart';
part 'time_entry.g.dart';

@freezed
class TimeEntry with _$TimeEntry {
  const factory TimeEntry({
    required String id,
    required DateTime startTime,
    required DateTime? endTime,
    String? description,
    required String userId,
    required String projectId,
    required DateTime createdAt,
    required DateTime updatedAt,
  }) = _TimeEntry;

  factory TimeEntry.fromJson(Map<String, dynamic> json) =>
      _$TimeEntryFromJson(json);
}

@freezed
class TimeEntryCreate with _$TimeEntryCreate {
  const factory TimeEntryCreate({
    String? id,
    required DateTime startTime,
     DateTime? endTime,
    String? description,
    required String userId,
    required String projectId,
  }) = _TimeEntryCreate;

  factory TimeEntryCreate.fromJson(Map<String, dynamic> json) =>
      _$TimeEntryCreateFromJson(json);
}

@freezed
class TimeEntryUpdate with _$TimeEntryUpdate {
  const factory TimeEntryUpdate({
    required String id,
    DateTime? startTime,
    DateTime? endTime,
    String? description,
    String? userId,
    String? projectId,
  }) = _TimeEntryUpdate;

  factory TimeEntryUpdate.fromJson(Map<String, dynamic> json) =>
      _$TimeEntryUpdateFromJson(json);
}
