import 'package:freezed_annotation/freezed_annotation.dart';

part 'user.freezed.dart';

@freezed
class User with _$User {
  const factory User({
    required String id,
    required String name,
    required String email,
    String? passwordHash,
    DateTime? createdAt,
    DateTime? updatedAt,
  }) = _User;
}

@freezed
class UserCreate with _$UserCreate {
  const factory UserCreate({
    String? id,
    required String name,
    required String email,
    required String password,
  }) = _UserCreate;
}

@freezed
class UserUpdate with _$UserUpdate {
  const factory UserUpdate({
    required String id,
    String? name,
    String? email,
    String? password,
  }) = _UserUpdate;
}
