import 'package:fpdart/fpdart.dart';
import 'package:backend_dart/domain/entities/project.dart';
import 'package:backend_dart/domain/interface/error.dart';

abstract class ProjectRepository {
  /// Creates a new project.
  TaskEither<IError, Project> create(ProjectCreate project);

  /// Finds a project by its unique ID.
  TaskEither<IError, Project> findById(String id);

  /// Updates an existing project.
  TaskEither<IError, Project> update(ProjectUpdate project);

  /// Deletes a project by its unique ID.
  TaskEither<IError, void> delete(String id);

  /// Finds all projects.
  TaskEither<IError, List<Project>> findAll();
}
